﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Example1MultipleMatrix
{
    class CMatrix
    {
        protected int size;
        protected float[,] matr;
        public CMatrix(int size)
        {
            this.size = size;
            matr = new float[size, size];
        }
        public void Generate(int min, int max)
        {
            Random rnd = new Random();
          
            for (int i = 0; i < size; i++)
                for (int j = 0; j < size; j++)
                    matr[i, j] = rnd.Next(min * 100, max * 100) / 100;
        }
        public CMatrix MultiplePosl(CMatrix obj)
        {
            CMatrix newMatr = new CMatrix(size);
            for (int i = 0; i < size; i++)
                for (int j = 0; j < size; j++)
                    for (int k = 0; k < size; k++)
                    newMatr.matr[i, j] += matr[i, k] * obj.matr[k, j];
            return newMatr;
        }
        public CMatrix MultipleParal(CMatrix obj)
        {
            CMatrix newMatr = new CMatrix(size);
            Parallel.For(0, size, delegate(int i)
            {
                for (int j = 0; j < size; j++)
                    for (int k = 0; k < size; k++)
                        newMatr.matr[i, j] += matr[i, k] * obj.matr[k, j];
            });
           
            return newMatr;
        }
    }
}
