﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using System.ServiceModel.Description;
using Example2Lib;

namespace Example2Server
{
    public partial class Form1 : Form
    {
        protected ServiceHost sh;
        public Form1()
        {
            InitializeComponent();
        }
        public void startServer()
        {
            sh = new ServiceHost(typeof(CSummator),
                new Uri("http://localhost:9000/Sum"));
            sh.AddServiceEndpoint(typeof(CSummator), new BasicHttpBinding(), "");

            ServiceMetadataBehavior sb = new ServiceMetadataBehavior();
            sb.HttpGetEnabled = true;

            sh.Description.Behaviors.Add(sb);
            sh.AddServiceEndpoint(typeof(IMetadataExchange), MetadataExchangeBindings.CreateMexHttpBinding(), "mex");            
            sh.Open();
            button1.Enabled = false;
            button2.Enabled = true;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            startServer();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            sh.Close();
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            startServer();
        }
    }
}
